Attribute VB_Name = "Module1"
Public Valentina As New Valentina

Public gConn As VConnection
Public gConn_Local As VConnection

Public gDatabase As VDatabase
Public gDatabase_Local As VDatabase

Sub Valentina_Initialize(inCacheSize As Long)
    
    Valentina.Init 10, "VCOM-W-2W3K769M4NJ2C5TA-4S8L179R4JJKU87P-SH3W8MHJSR2ZMMQZ-Y45WHM8KTR71DN12"
    Valentina.InitClient
    Valentina.DebugLevel = EVDebugLevel.kLogErrors '.kLogFunctions
    
End Sub

Sub Valentina_Shutdown()
  
    On Error Resume Next 'GoTo BailOut
    
    If Not gDatabase Is Nothing Then gDatabase.Close
    If Not gDatabase_Local Is Nothing Then gDatabase_Local.Close
    If Not gConn Is Nothing Then gConn.Close
    If Not gConn_Local Is Nothing Then gConn_Local.Close
    
    'Valentina.ShutDownClient  '//don't think this is needed
    Valentina.ShutDown
    
bailout:
    Set gDatabase = Nothing
    Set gDatabase_Local = Nothing
    Set gConn = Nothing
    Set gConn_Local = Nothing
    Set Valentina = Nothing
    
End Sub

Sub CreateRemoteTableAndData()

    Dim tblTest As VTable, mTest As VTable
    Dim fld_string As VField, fld_varchar As VField
    
    gDatabase.SqlExecute ("DROP TABLE IF EXISTS test")
    
    Set tblTest = gDatabase.CreateTable("test")
    Set mTest = tblTest
      
    Set fld_string = tblTest.CreateStringField("fldStr", 40)
    Set fld_varchar = tblTest.CreateVarCharField("fldVar", 1024)
      
      
    mTest.Field("fldStr").Value = "1234567890123456789012345678901234567890"
    mTest.Field("fldVar").Value = "1234567890123456789012345678901234567890"
    Call mTest.AddRecord
      
      
    Set fld_string = Nothing
    Set fld_varchar = Nothing
    Set mTest = Nothing
    Set tblTest = Nothing
  
End Sub

Sub OpenDatabase_Remote(ByVal Host$, ByVal UserName$, ByVal Password$, ByVal dbName$)
    
    Set gConn = New VConnection
    gConn.Init Host$, UserName$, Password$  'gConn.Init "192.168.0.16", "GEORGEP", "GEORGEP"
    gConn.Open
        
    Set gDatabase = New VDatabase
    gDatabase.InitClient gConn
    
    On Error GoTo Err
    
    gDatabase.Open dbName$
    gDatabase.DateFormat = kMDY
    gDatabase.DateSep = "-"
    Exit Sub
    
Err:
    On Error GoTo Err2
    gDatabase.Create dbName$
    gDatabase.DateFormat = EVDateFormat.kMDY
    gDatabase.DateSep = "-"
    Exit Sub

Err2:
    MsgBox "COULD NOT CREATE:" & vbCrLf & vbCrLf & dbName$, vbExclamation, "OpenDatabase_Remote"
    Set gDatabase = Nothing
        
End Sub


Sub OpenDatabase_Local(ByVal LocalDB$)
    
    Set gConn_Local = Valentina.GetLocalConnection
    gConn_Local.Open
    
    Set gDatabase_Local = New VDatabase
    gDatabase_Local.InitLocal kStorageDefault
    
    On Error GoTo Err
    
    gDatabase_Local.Open LocalDB$
    gDatabase_Local.DateFormat = EVDateFormat.kMDY
    gDatabase_Local.DateSep = "-"
    
    gDatabase_Local.SqlExecute ("DROP TABLE IF EXISTS Test")
    Exit Sub
    
Err:
    On Error GoTo Err2
    gDatabase_Local.Create LocalDB$, EVDbMode.kDscDatBlbInd    '//single vdb file
    gDatabase_Local.DateFormat = EVDateFormat.kMDY
    gDatabase_Local.DateSep = "-"
    Exit Sub

Err2:
    MsgBox "COULD NOT CREATE:" & vbCrLf & vbCrLf & LocalDB$, vbExclamation, "OpenDatabase_Local"
    Set gDatabase_Local = Nothing
        
End Sub

